🎉 Try the public beta of the new docs site at algolia.com/doc-beta! 🎉
Guides / Building Search UI / UI & UX patterns

Infinite scroll with Angular InstantSearch

An “infinite list” is a common way of displaying results. It’s especially well-suited to mobile devices and has two variants:

  • Infinite hits with a “See more” button at the end of a batch of results. Implement this with InstantSearch’s ais-infinite-hits widget.
  • Infinite scroll uses a listener on the scroll event (called when the user has scrolled to the end of the first batch of results). The following guidance implements such an infinite scroll. Find the complete example on GitHub.

If there are no hits, you should display a message to users and clear filters so they can start over.

Display a list of hits

The first step to creating the infinite scroll component is to render the results with the ais-infinite-hits connector. There’s an external Hit component, but it’s not the point of this guide. The intent is to keep the code simple.

Read more about connectors in the customizing widgets guide.

1
2
3
4
5
6
7
8
9
10
11
12
<!-- app.component.html -->
<ais-instantsearch [config]="config">
    <ais-search-box></ais-search-box>
    <ais-infinite-hits>
        <ng-template let-hits="hits" let-results="results" let-refine="showMore" >
            <div *ngFor="let hit of hits">
                <ais-highlight attribute="name" [hit]="hit"></ais-highlight>
            </div>
            <button (click)="refine()">Show More</button>
        </ng-template>
    </ais-infinite-hits>
</ais-instantsearch>
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
// app.component.ts
const searchClient = algoliasearch(
  "latency",
  "6be0576ff61c053d5f9a3225e2a90f76"
);

@Component({
  selector: "app-root",
  templateUrl: "./app.component.html",
  styleUrls: ["./app.component.css"]
})
export class AppComponent {
  public config = {
    indexName: "instant_search",
    searchClient
  };
}
1
2
3
4
5
6
7
8
9
10
11
12
13
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { NgAisModule } from "angular-instantsearch";

import { AppComponent } from "./app.component";

@NgModule({
  declarations: [AppComponent],
  imports: [NgAisModule.forRoot(), BrowserModule],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule {}

Track the scroll position

Once you have your results, the next step is to track the scroll position to determine when the rest of the content needs to be loaded (using the Intersection Observer API). Use the API to track when the bottom of the list (the “sentinel” element) enters the viewport. You can reuse the same element across different renders. The Web Fundamentals website discusses the use of this API in more detail.

Use the Intersection Observer API to create a directive that detects when an element is visible inside the viewport.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
import { AfterViewInit, Directive, ElementRef, EventEmitter, OnDestroy, Output } from "@angular/core";

@Directive({ selector: "[onVisible]" })
export class OnVisibleDirective implements AfterViewInit, OnDestroy {
  @Output() public onVisible: EventEmitter<any> = new EventEmitter();

  private _intersectionObserver?: IntersectionObserver;

  constructor(private _element: ElementRef) {}

  public ngAfterViewInit() {
    this._intersectionObserver = new IntersectionObserver(entries => {
      this.checkForIntersection(entries);
    }, {});
    this._intersectionObserver.observe(<Element>this._element.nativeElement);
  }

  public ngOnDestroy() {
    if (this._intersectionObserver) {
      this._intersectionObserver.disconnect();
    }
  }

  private checkForIntersection = (
    entries: Array<IntersectionObserverEntry>
  ) => {
    entries.forEach((entry: IntersectionObserverEntry) => {
      const isIntersecting =
        (<any>entry).isIntersecting &&
        entry.target === this._element.nativeElement;

      if (isIntersecting) {
        this.onVisible.emit();
      }
    });
  };
}

Now declare it in the main app module and use it.

1
2
3
4
5
6
7
8
9
10
11
12
13
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { NgAisModule } from "angular-instantsearch";

import { AppComponent } from "./app.component";

@NgModule({
  declarations: [AppComponent],
  imports: [NgAisModule.forRoot(), BrowserModule],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule {}

This implementation uses the Intersection Observer API. However, since the Intersection Observer API isn’t widely supported, consider using a polyfill. A browser API is used in the example, but you can apply the concepts to any infinite scroll library.

Retrieve more results

Now that you can track when you reach the end of the results, use the showMore function exposed in the template to the onVisible directive.

1
2
3
4
5
6
7
8
9
10
11
12
<!-- app.component.html -->
<ais-instantsearch [config]="config">
    <ais-search-box></ais-search-box>
    <ais-infinite-hits>
        <ng-template let-hits="hits" let-results="results" let-refine="showMore" >
            <div *ngFor="let hit of hits">
                <ais-highlight attribute="name" [hit]="hit"></ais-highlight>
            </div>
            <div (onVisible)="refine()"></div>
        </ng-template>
    </ais-infinite-hits>
</ais-instantsearch>

Show more than 1,000 results

To ensure excellent performance, the default limit for the number of hits you can retrieve for a query is 1,000. When building an infinite scroll, you should stay within this limit.

1
2
3
$index->setSettings([
  'paginationLimitedTo' => 1000
]);

Increasing the limit doesn’t mean you can go until the end of the hits, but just that Algolia will go as far as possible in the index to retrieve results in a reasonable time.

Did you find this page helpful?

Guides / Building Search UI / UI & UX patterns

Infinite scroll with Vue InstantSearch

The infinite list is a very common pattern to display a list of results. This pattern has two variants:

  • A clickable button at the end of the list of results
  • A listener on the scroll event that is called when the list of results reaches the end

Vue InstantSearch can cover those two different implementations. The former is covered by the built-in ais-infinite-hits widget and the latter is covered by the ais-infinite-hits connector. This guide focuses on the second implementation using the Intersection Observer API. A browser API is used in the example but the concepts can be applied to any kind of infinite scroll library. You can find the complete example on GitHub.

Note that the Intersection Observer API isn’t yet widely supported. You may want to consider using a polyfill. Here the compatibility table to find more information about its support.

Display a list of hits

The first step to creating an infinite scroll component is to render the results with the ais-infinite-hits connector. There’s an external Hit component but it’s not the point of this guide, the intent is to keep the code simple. You can find more information about the connectors API in the dedicated guide about widget customisation.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
<template>
  <ol v-if="state">
    <li v-for="hit in state.hits" :key="hit.objectID">
      <slot name="item" :item="hit"> </slot>
    </li>
  </ol>
</template>

<script>
import { createWidgetMixin } from 'vue-instantsearch';
import { connectInfiniteHits } from 'instantsearch.js/es/connectors';

export default {
  mixins: [createWidgetMixin({ connector: connectInfiniteHits })],
};
</script>

Track the scroll position

Once you have your list of results, the next step is to track the scroll position to determine when the rest of the content needs to be loaded. For this purpose, the Intersection Observer API is used. To track when the bottom of the list enters the viewport, a “sentinel” element is observed. This trick is used to avoid observing all the items of the results. You can reuse the same element across the different renders. You can find more information about this pattern on the Web Fundamentals website.

You can use the vue-observe-visibility library to determine when the sentinel is visible.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
<template>
  <ol v-if="state">
    <li v-for="hit in state.hits" :key="hit.objectID">
      <slot name="item" :item="hit"> </slot>
    </li>
    <li class="sentinel" v-observe-visibility="visibilityChanged" />
  </ol>
</template>

<script>
import { createWidgetMixin } from 'vue-instantsearch';
import { connectInfiniteHits } from 'instantsearch.js/es/connectors';

export default {
  mixins: [createWidgetMixin({ connector: connectInfiniteHits })],
  methods: {
    visibilityChanged(isVisible, e) {
      console.log(isVisible, e);
    },
  },
};
</script>

<style scoped>
.sentinel {
  list-style-type: none;
}
</style>

Retrieve more results

Now that you can track when you reach the end of the results, you can use the showMore function inside the callback function onSentinelIntersection. But you should only trigger the function when you still have results to retrieve. For this use case, the connector provides a prop isLastPage that indicates if you still have results to load or not.

1
2
3
4
5
6
7
8
9
10
11
<script>
export default {
  methods: {
    visibilityChanged(isVisible) {
      if (isVisible && !this.state.isLastPage) {
        this.state.showMore();
      }
    },
  },
};
</script>

Go further than 1000 hits

By default Algolia limits the number of hits you can retrieve for a query to 1000. When doing an infinite scroll, you usually don’t want to go over this limit.

1
2
3
$index->setSettings([
  'paginationLimitedTo' => 1000
]);

Disabling the limit doesn’t mean that you can go until the end of the hits, but just that Algolia will go as far as possible in the index to retrieve results in a reasonable time.

Now you should have a complete infinite scroll experience.

The complete source code of the example is on GitHub.

Did you find this page helpful?

Guides / Building Search UI / UI & UX patterns

Infinite scroll with React InstantSearch

We released React InstantSearch Hooks, a new InstantSearch library for React. We recommend using React InstantSearch Hooks in new projects or upgrading from React InstantSearch.

An “infinite list” is a common way of displaying results. It’s especially well-suited to mobile devices and has two variants:

  • Infinite hits with a “See more” button at the end of a batch of results. Implement this with InstantSearch’s InfiniteHits widget.
  • Infinite scroll uses a listener on the scroll event (called when the user has scrolled to the end of the first batch of results). The following guidance implements such an infinite scroll. Find the complete example on GitHub.

If there are no hits, you should display a message to users and clear filters so they can start over.

Display a list of hits

The first step is to render the results with the connectInfiniteHits connector. There’s an external Hit component, but it’s not the point of this guide. The intent is to keep the code simple.

Read more about connectors in the customizing widgets guide.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
import React, { Component } from 'react';
import { connectInfiniteHits } from 'react-instantsearch-dom';
import Hit from './Hit';

class InfiniteHits extends Component {
  render() {
    const { hits } = this.props;

    return (
      <div className="ais-InfiniteHits">
        <ul className="ais-InfiniteHits-list">
          {hits.map(hit => (
            <li key={hit.objectID} className="ais-InfiniteHits-item">
              <Hit hit={hit} />
            </li>
          ))}
        </ul>
      </div>
    );
  }
}

export default connectInfiniteHits(InfiniteHits);

Track the scroll position

Once you have your results, the next step is to track the scroll position to determine when the rest of the content needs to be loaded (using the Intersection Observer API). Use the API to track when the bottom of the list (the “sentinel” element) enters the viewport. You can reuse the same element across different renders. The Web Fundamentals website discusses the use of this API in more detail.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
class InfiniteHits extends Component {
  sentinel = null;

  render() {
    const { hits } = this.props;

    return (
      <div className="ais-InfiniteHits">
        <ul className="ais-InfiniteHits-list">
          {hits.map(hit => (
            <li key={hit.objectID} className="ais-InfiniteHits-item">
              <Hit hit={hit} />
            </li>
          ))}
          <li
            className="ais-InfiniteHits-sentinel"
            ref={c => (this.sentinel = c)}
          />
        </ul>
      </div>
    );
  }
}

This implementation uses the Intersection Observer API. However, since the Intersection Observer API isn’t widely supported, consider using a polyfill. A browser API is used in the example, but you can apply the concepts to any infinite scroll library.

Once you have the ref of the “sentinel” element, create the Intersection Observer instance to observe when the element enters the page. Update the Intersection Observer’s options object to adjust this code to your needs.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
class InfiniteHits extends Component {
  onSentinelIntersection = entries => {
    entries.forEach(entry => {
      if (entry.isIntersecting) {
        // In that case, you can refine
      }
    });
  };

  componentDidMount() {
    this.observer = new IntersectionObserver(this.onSentinelIntersection);

    this.observer.observe(this.sentinel);
  }

  render() {
    const { hits } = this.props;

    return (
      <div className="ais-InfiniteHits">
        <ul className="ais-InfiniteHits-list">
          {hits.map(hit => (
            <li key={hit.objectID} className="ais-InfiniteHits-item">
              <Hit hit={hit} />
            </li>
          ))}
          <li
            className="ais-InfiniteHits-sentinel"
            ref={c => (this.sentinel = c)}
          />
        </ul>
      </div>
    );
  }
}

Clear the observer once the component is unmounted.

1
2
3
4
5
6
7
8
9
class InfiniteHits extends Component {
  componentWillUnmount() {
    this.observer.disconnect();
  }

  render() {
    // ...
  }
}

Retrieve more results

Now that you can track when you reach the end of the results, use the refineNext function inside the callback function onSentinelIntersection. Only trigger the function when there are still results to retrieve. For this use case, the connector provides a prop hasMore that indicates if you still have results.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class InfiniteHits extends Component {
  onSentinelIntersection = entries => {
    const { hasMore, refineNext } = this.props;

    entries.forEach(entry => {
      if (entry.isIntersecting && hasMore) {
        refineNext();
      }
    });
  };

  render() {
    // ...
  }
}

Show more than 1,000 hits

To ensure excellent performance, the default limit for the number of hits you can retrieve for a query is 1,000.

1
2
3
$index->setSettings([
  'paginationLimitedTo' => 1000
]);

Increasing the limit doesn’t mean you can go until the end of the hits, but just that Algolia will go as far as possible in the index to retrieve results in a reasonable time.

Did you find this page helpful?